#include <arpa/inet.h>
#include <assert.h>
#include <ctype.h>
#include <db.h>
#include <errno.h>
#include <fcntl.h>
#include <netdb.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/ipc.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/types.h>
#include <sys/un.h>
#include <sys/wait.h>
#include <syslog.h>
#include <termios.h>
#include <time.h>
#include <unistd.h>

/* Tunables */

#define BACKLOG 10
#define SOCKET "/var/run/smsotp_socket"
#define DATABASE "/home/sithglan/work/smsotpd/users"
#define SEND_SMS_BINARY "/home/sithglan/work/smsotpd/c/send_email.sh"
#define OTP_TTL (60 * 10)
#define OTP_MODULO 99999
#define PIDFILE "/var/run/smsotpd.pid"

#define dprintf(...) if (debug) { syslog(LOG_DEBUG, __VA_ARGS__); }

/* Macros */

#define die(format, ...) \
{ \
        syslog(LOG_ERR, \
                "%s(%d): %d: %s: %s: " format, \
                __FILE__, getpid(), (int) __LINE__, __FUNCTION__, strerror(errno), __VA_ARGS__); \
        exit(EXIT_FAILURE); \
}

/* Function prototypes */

int
server_listen_unix_socket(const char *name);

void
handle_client(int fd);

void
db_open(char *filename, int flags);

void
db_close(void);

char *
db_fetch (char *key);

void
db_put(char *key, char *value);

void
create_berkley_db(char *file);

/* Global Datastructure Prototypes */

extern int debug;
